# CfnFleet

The `AWS::AppStream::Fleet` resource creates a fleet for Amazon AppStream 2.0. A fleet consists of streaming instances that run a specified image when using Always-On or On-Demand.

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnFleet
Implements: IInspectable, ITaggable, IEnvironmentAware, IFleetRef, IConstruct, IDependable

- CloudFormation: [`AWS::AppStream::Fleet`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-appstream-fleet.html)
- Source: Generated code
- Type last changed: v2.273.0 · 8 Oct 2026

## Example

```ts
const fleet = new appstream.CfnFleet(this, 'Fleet', {
  instanceType: 'stream.standard.small',
  name: 'Fleet',
  computeCapacity: {
    desiredInstances: 1,
  },
  imageName: 'AppStream-AmazonLinux2-09-21-2022',
});
fleet.cfnOptions.creationPolicy = {
  startFleet: true,
};
```

## Initializer

```ts
new CfnFleet(scope: Construct, id: string, props: CfnFleetProps)
```

## Construct Props

- `attributesToDelete`: string[]

- `computeCapacity`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFleet.ComputeCapacityProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_appstream.CfnFleet.ComputeCapacityProperty.html) — The desired capacity for the fleet.

  This is not allowed for Elastic fleets.

- `description`: string — The description to display.

- `disableImdsv1`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html)

- `disconnectTimeoutInSeconds`: number — The amount of time that a streaming session remains active after users disconnect.

  If users try to reconnect to the streaming session after a disconnection or network interruption within this time interval, they are connected to their previous session. Otherwise, they are connected to a new session with a new streaming instance.

  Specify a value between 60 and 36000.

- `displayName`: string — The fleet name to display.

- `domainJoinInfo`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFleet.DomainJoinInfoProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_appstream.CfnFleet.DomainJoinInfoProperty.html) — The name of the directory and organizational unit (OU) to use to join the fleet to a Microsoft Active Directory domain.

  This is not allowed for Elastic fleets.

- `enableDefaultInternetAccess`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Enables or disables default internet access for the fleet.

- `fleetType`: string — The fleet type.

  - **ALWAYS_ON** - Provides users with instant-on access to their apps. You are charged for all running instances in your fleet, even if no users are streaming apps.
  - **ON_DEMAND** - Provide users with access to applications after they connect, which takes one to two minutes. You are charged for instance streaming when users are connected and a small hourly fee for instances that are not streaming apps.
  - **ELASTIC** - The pool of streaming instances is managed by Amazon AppStream 2.0. When a user selects their application or desktop to launch, they will start streaming after the app block has been downloaded and mounted to a streaming instance.

  *Allowed Values* : `ALWAYS_ON` | `ELASTIC` | `ON_DEMAND`

- `iamRoleArn`: string — The ARN of the IAM role that is applied to the fleet.

  To assume a role, the fleet instance calls the Security Token Service `AssumeRole` API operation and passes the ARN of the role to use. The operation creates a new session with temporary credentials. AppStream 2.0 retrieves the temporary credentials and creates the *appstream_machine_role* credential profile on the instance.

  For more information, see [Using an IAM Role to Grant Permissions to Applications and Scripts Running on AppStream 2.0 Streaming Instances](https://docs.aws.amazon.com/appstream2/latest/developerguide/using-iam-roles-to-grant-permissions-to-applications-scripts-streaming-instances.html) in the *Amazon AppStream 2.0 Administration Guide* .

- `idleDisconnectTimeoutInSeconds`: number — The amount of time that users can be idle (inactive) before they are disconnected from their streaming session and the `DisconnectTimeoutInSeconds` time interval begins.

  Users are notified before they are disconnected due to inactivity. If they try to reconnect to the streaming session before the time interval specified in `DisconnectTimeoutInSeconds` elapses, they are connected to their previous session. Users are considered idle when they stop providing keyboard or mouse input during their streaming session. File uploads and downloads, audio in, audio out, and pixels changing do not qualify as user activity. If users continue to be idle after the time interval in `IdleDisconnectTimeoutInSeconds` elapses, they are disconnected.

  To prevent users from being disconnected due to inactivity, specify a value of 0. Otherwise, specify a value between 60 and 36000.

  If you enable this feature, we recommend that you specify a value that corresponds exactly to a whole number of minutes (for example, 60, 120, and 180). If you don't do this, the value is rounded to the nearest minute. For example, if you specify a value of 70, users are disconnected after 1 minute of inactivity. If you specify a value that is at the midpoint between two different minutes, the value is rounded up. For example, if you specify a value of 90, users are disconnected after 2 minutes of inactivity.

- `imageArn`: string — The ARN of the public, private, or shared image to use.

- `imageName`: string — The name of the image used to create the fleet.

- `instanceType`: string (required) — The instance type to use when launching fleet instances. The following instance types are available for non-Elastic fleets:.

  - stream.standard.small
  - stream.standard.medium
  - stream.standard.large
  - stream.compute.large
  - stream.compute.xlarge
  - stream.compute.2xlarge
  - stream.compute.4xlarge
  - stream.compute.8xlarge
  - stream.memory.large
  - stream.memory.xlarge
  - stream.memory.2xlarge
  - stream.memory.4xlarge
  - stream.memory.8xlarge
  - stream.memory.z1d.large
  - stream.memory.z1d.xlarge
  - stream.memory.z1d.2xlarge
  - stream.memory.z1d.3xlarge
  - stream.memory.z1d.6xlarge
  - stream.memory.z1d.12xlarge
  - stream.graphics-design.large
  - stream.graphics-design.xlarge
  - stream.graphics-design.2xlarge
  - stream.graphics-design.4xlarge
  - stream.graphics.g4dn.xlarge
  - stream.graphics.g4dn.2xlarge
  - stream.graphics.g4dn.4xlarge
  - stream.graphics.g4dn.8xlarge
  - stream.graphics.g4dn.12xlarge
  - stream.graphics.g4dn.16xlarge
  - stream.graphics.g5.xlarge
  - stream.graphics.g5.2xlarge
  - stream.graphics.g5.4xlarge
  - stream.graphics.g5.8xlarge
  - stream.graphics.g5.16xlarge
  - stream.graphics.g5.12xlarge
  - stream.graphics.g5.24xlarge
  - stream.graphics.g6.xlarge
  - stream.graphics.g6.2xlarge
  - stream.graphics.g6.4xlarge
  - stream.graphics.g6.8xlarge
  - stream.graphics.g6.16xlarge
  - stream.graphics.g6.12xlarge
  - stream.graphics.g6.24xlarge
  - stream.graphics.gr6.4xlarge
  - stream.graphics.gr6.8xlarge
  - stream.graphics.g6f.large
  - stream.graphics.g6f.xlarge
  - stream.graphics.g6f.2xlarge
  - stream.graphics.g6f.4xlarge
  - stream.graphics.gr6f.4xlarge

  The following instance types are available for Elastic fleets:

  - stream.standard.small
  - stream.standard.medium

- `maxConcurrentSessions`: number — The maximum number of concurrent sessions that can be run on an Elastic fleet.

  This setting is required for Elastic fleets, but is not used for other fleet types.

- `maxSessionsPerInstance`: number — Max number of user sessions on an instance.

  This is applicable only for multi-session fleets.

- `maxUserDurationInSeconds`: number — The maximum amount of time that a streaming session can remain active, in seconds.

  If users are still connected to a streaming instance five minutes before this limit is reached, they are prompted to save any open documents before being disconnected. After this time elapses, the instance is terminated and replaced by a new instance.

  Specify a value between 600 and 432000.

- `name`: string (required) — A unique name for the fleet.

- `platform`: string — The platform of the fleet.

  Platform is a required setting for Elastic fleets, and is not used for other fleet types.

- `rootVolumeConfig`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFleet.VolumeConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_appstream.CfnFleet.VolumeConfigProperty.html)

- `sessionScriptS3Location`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFleet.S3LocationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_appstream.CfnFleet.S3LocationProperty.html) — The S3 location of the session scripts configuration zip file.

  This only applies to Elastic fleets.

- `streamView`: string — The WorkSpaces Applications view that is displayed to your users when they stream from the fleet.

  When `APP` is specified, only the windows of applications opened by users display. When `DESKTOP` is specified, the standard desktop that is provided by the operating system displays.

  The default value is `APP` .

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — An array of key-value pairs.

- `usbDeviceFilterStrings`: string[] — The USB device filter strings that specify which USB devices a user can redirect to the fleet streaming session, when using the Windows native client.

  This is allowed but not required for Elastic fleets.

- `vpcConfig`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFleet.VpcConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_appstream.CfnFleet.VpcConfigProperty.html) — The VPC configuration for the fleet.

  This is required for Elastic fleets, but not required for other fleet types.

## Properties

- `attrArn`: string

- `attributesToDelete`: string[]

- `attrId`: string

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `computeCapacity`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFleet.ComputeCapacityProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_appstream.CfnFleet.ComputeCapacityProperty.html) — The desired capacity for the fleet.

- `creationStack`: string[]

- `description`: string — The description to display.

- `disableImdsv1`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html)

- `disconnectTimeoutInSeconds`: number — The amount of time that a streaming session remains active after users disconnect.

- `displayName`: string — The fleet name to display.

- `domainJoinInfo`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFleet.DomainJoinInfoProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_appstream.CfnFleet.DomainJoinInfoProperty.html) — The name of the directory and organizational unit (OU) to use to join the fleet to a Microsoft Active Directory domain.

- `enableDefaultInternetAccess`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Enables or disables default internet access for the fleet.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `fleetRef`: [FleetReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_appstream.FleetReference.html) — A reference to a Fleet resource.

- `fleetType`: string — The fleet type.

- `iamRoleArn`: string — The ARN of the IAM role that is applied to the fleet.

- `idleDisconnectTimeoutInSeconds`: number — The amount of time that users can be idle (inactive) before they are disconnected from their streaming session and the `DisconnectTimeoutInSeconds` time interval begins.

- `imageArn`: string — The ARN of the public, private, or shared image to use.

- `imageName`: string — The name of the image used to create the fleet.

- `instanceType`: string — The instance type to use when launching fleet instances.

  The following instance types are available for non-Elastic fleets:.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `maxConcurrentSessions`: number — The maximum number of concurrent sessions that can be run on an Elastic fleet.

- `maxSessionsPerInstance`: number — Max number of user sessions on an instance.

- `maxUserDurationInSeconds`: number — The maximum amount of time that a streaming session can remain active, in seconds.

- `name`: string — A unique name for the fleet.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `platform`: string — The platform of the fleet.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `rootVolumeConfig`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFleet.VolumeConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_appstream.CfnFleet.VolumeConfigProperty.html)

- `sessionScriptS3Location`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFleet.S3LocationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_appstream.CfnFleet.S3LocationProperty.html) — The S3 location of the session scripts configuration zip file.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `streamView`: string — The WorkSpaces Applications view that is displayed to your users when they stream from the fleet.

- `tags`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `tagsRaw`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — An array of key-value pairs.

- `usbDeviceFilterStrings`: string[] — The USB device filter strings that specify which USB devices a user can redirect to the fleet streaming session, when using the Windows native client.

- `vpcConfig`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFleet.VpcConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_appstream.CfnFleet.VpcConfigProperty.html) — The VPC configuration for the fleet.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForFleet(resource: IFleetRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `fromFleetArn(scope: Construct, id: string, arn: string): IFleetRef` (static) — Creates a new IFleetRef from an ARN.

- `fromFleetName(scope: Construct, id: string, fleetName: string): IFleetRef` (static) — Creates a new IFleetRef from a fleetName.

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnFleet(x: any): boolean` (static) — Checks whether the given object is a CfnFleet.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
